<script setup lang="ts">
import { useAuthStore } from '@/stores/auth'
import attendanceService from '@/services/attendance'
import { onUnmounted, ref } from 'vue'
import { useAttendanceStore } from '@/stores/attendance'
import { onMounted } from 'vue'
const authStore = useAuthStore()
const attendanceStore = useAttendanceStore()
const currentTime = ref<string>(
  new Date().toLocaleString('th-TH', { hour12: false, timeZone: 'Asia/Bangkok' })
)

const updateTime = () => {
  currentTime.value = new Date().toLocaleString('th-TH', {
    hour12: false,
    timeZone: 'Asia/Bangkok'
  })
}

const isClockIn = ref<boolean>(true)

async function clockIn() {
  try {
    const currentUser = authStore.getCurrentUser()?.employee?.id
    if (currentUser) {
      await attendanceService.clockIn(authStore.getCurrentUser()?.employee!)
      isClockIn.value = false // เปลี่ยนสถานะเป็น clock out
    }
  } catch (error) {
    console.error('Error while clocking in:', error)
  }
}

async function clockOut() {
  await attendanceStore.clockOut()
}

async function toggleClockAction() {
  // ตรวจสอบสถานะปัจจุบัน
  if (isClockIn.value) {
    await clockIn()
    console.log('checkIn')
  } else {
    // ถ้าไม่ใช่ clock in ให้ทำการ clock out
    await clockOut()
    console.log('checkOut')
  }
}

const intervalId = setInterval(updateTime, 1000)

onUnmounted(() => {
  clearInterval(intervalId)
})

onMounted(() => {
  console.log(authStore.getCurrentUser()?.employee?.id!)

  attendanceStore.getAllAttendanceByEmployeeId(authStore.getCurrentUser()?.employee?.id!)
  console.log(attendanceStore.attendances)
})
</script>

<template>
  <v-container>
    <v-card
      style="background-color: rgb(247, 156, 82); border-radius: 30px; border: 15px solid white"
    >
      <v-card-title class="font-weight-bold" style="font-size: 35px; color: white">
        Clock In/Out
      </v-card-title>
      <v-container>
        <v-row class="d-flex justify-center align-center">
          <v-col col="12" sm="4" class="d-flex justify-center align-center">
            <v-img
              :src="`http://localhost:4000/images/users/${authStore.getCurrentUser()?.image}`"
              style="max-width: 200px; max-height: 200px"
            ></v-img>
          </v-col>
          <v-col col="12" sm="4">
            <v-list-item
              class="font-weight-bold text-center"
              :style="{ fontSize: '35px', color: 'white' }"
            >
              {{ authStore.getCurrentUser()?.employee?.name }}
            </v-list-item>
          </v-col>
          <v-col>
            <v-btn
              class="mt-0"
              :color="isClockIn ? 'green' : 'red darken-2'"
              :style="{
                borderRadius: '50%',
                width: '150px',
                height: '150px',
                boxShadow: '0px 4px 6px rgba(0, 0, 0, 1)',
                fontSize: '20px',
                fontWeight: 'bold'
              }"
              @click="toggleClockAction()"
            >
              {{ isClockIn ? 'Clock In' : 'Clock Out' }}
            </v-btn>
          </v-col>
          <v-col col="12" sm="4" class="font-weight-bold text-center">
            <v-subheader style="font-size: 40px; color: white">{{ currentTime }}</v-subheader>
          </v-col>
        </v-row>
      </v-container>
    </v-card>

    <v-container class="d-flex justify-center align-center"> </v-container>
  </v-container>
</template>
